Index: binaries/data/mods/public/maps/random/rmgen/wall_builder.js
===================================================================
--- binaries/data/mods/public/maps/random/rmgen/wall_builder.js
+++ binaries/data/mods/public/maps/random/rmgen/wall_builder.js
@@ -920,41 +896,31 @@ function placeIrregularPolygonalWall(centerX, centerY, radius, cornerWallElement
 //	This is the default Iberian civ bonus starting wall
 //
 //	centerX/Y      The approximate center coordinates of the fortress
-//	radius         The approximate radius of the wall to be placed
+//	radius         Optional. The approximate radius of the wall to be placed. Default is 20
 //	playerId       Optional. Integer number of the player. Default is 0 (gaia)
 //	style          Optional. Wall style string. Default is the civ of the given player, "palisades" for gaia
-//	irregularity   Optional. Float between 0 (circle) and 1 (very spiky), default is 1/2
+//	irregularity   Optional. Float between 0 (circle) and 1 (very spiky), default is 0.5
 //	gateOccurence  Optional. Integer number, every n-th walls will be a gate instead. Default is 3
 //	maxTrys        Optional. How often the function tries to find a better fitting shape at max. Default is 100
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-function placeGenericFortress(centerX, centerY, radius, playerId, style, irregularity, gateOccurence, maxTrys)
+function placeGenericFortress(centerX, centerY, radius=20, playerId=0, style, irregularity=0.5, gateOccurence=3, maxTrys=100)
 {
 	// Setup optional arguments
-	radius = (radius || 20);
-	playerId = (playerId || 0);
-	if (!wallStyles.hasOwnProperty(style))
-	{
-		if (playerId == 0)
-			style = (style || "palisades");
-		else
-			style = (getCivCode(playerId-1));
-	}
-	irregularity = (irregularity || 1/2);
-	gateOccurence = (gateOccurence || 3);
-	maxTrys = (maxTrys || 100);
+	if (!style || g_WallStyleList.indexOf(style) == -1)
+		style = (playerId == 0) ? "palisade" : getCivCode(playerId-1)+"_stone";
 	
 	// Setup some vars
 	var startAngle = randFloat(0, 2*PI);
 	var actualOffX = radius*cos(startAngle);
 	var actualOffY = radius*sin(startAngle);
 	var actualAngle = startAngle;
-	var pointDistance = wallStyles[style]["wallLong"].width + wallStyles[style]["tower"].width;
+	var pointDistance = getWallLength(style, ["long", "tower"]);
 	// Searching for a well fitting point derivation
 	var tries = 0;
 	var bestPointDerivation = undefined;
 	var minOverlap = 1000;
 	var overlap = undefined;
-	while (tries < maxTrys && minOverlap > wallStyles[style]["tower"].width / 10)
+	while (tries < maxTrys && minOverlap > getOverlap(style))
 	{
 		var pointDerivation = [];
 		var distanceToTarget = 1000;
@@ -963,8 +929,8 @@ function placeGenericFortress(centerX, centerY, radius, playerId, style, irregul
 		{
 			var indent = randFloat(-irregularity*pointDistance, irregularity*pointDistance);
 			var tmpAngle = getAngle(actualOffX, actualOffY,
-				(radius + indent)*cos(actualAngle + (pointDistance / radius)),
-				(radius + indent)*sin(actualAngle + (pointDistance / radius)));
+				(radius + indent)*cos(actualAngle + pointDistance / radius),
+				(radius + indent)*sin(actualAngle + pointDistance / radius));
 			actualOffX += pointDistance*cos(tmpAngle);
 			actualOffY += pointDistance*sin(tmpAngle);
 			actualAngle = getAngle(0, 0, actualOffX, actualOffY);
@@ -982,31 +948,34 @@ function placeGenericFortress(centerX, centerY, radius, playerId, style, irregul
 				}
 			}
 		}
-		tries++;
+		++tries;
 	}
 	log("placeGenericFortress: Reduced overlap to " + minOverlap + " after " + tries + " tries");
 	// Place wall
-	for (var pointIndex = 0; pointIndex < bestPointDerivation.length; pointIndex++)
+	for (var pointIndex = 0; pointIndex < bestPointDerivation.length; ++pointIndex)
 	{
 		var startX = centerX + bestPointDerivation[pointIndex][0];
 		var startY = centerY + bestPointDerivation[pointIndex][1];
 		var targetX = centerX + bestPointDerivation[(pointIndex + 1) % bestPointDerivation.length][0];
 		var targetY = centerY + bestPointDerivation[(pointIndex + 1) % bestPointDerivation.length][1];
 		var angle = getAngle(startX, startY, targetX, targetY);
-		var wallElement = "wallLong";
+		var wallElement = "long";
 		if ((pointIndex + 1) % gateOccurence == 0)
 			wallElement = "gate";
-		var entity = wallStyles[style][wallElement].entity;
-		if (entity)
+
+		var entPath = getWallElement(style, wallElement).entPath;
+		if (entPath)
 		{
 			placeObject(startX + (getDistance(startX, startY, targetX, targetY)/2)*cos(angle), // placeX
 				startY + (getDistance(startX, startY, targetX, targetY)/2)*sin(angle), // placeY
-				entity, playerId, angle - PI/2 + wallStyles[style][wallElement].angle);
+				entPath, playerId, angle - PI/2 + getWallElement(style, wallElement).angle);
 		}
 		// Place tower
 		var startX = centerX + bestPointDerivation[(pointIndex + bestPointDerivation.length - 1) % bestPointDerivation.length][0];
 		var startY = centerY + bestPointDerivation[(pointIndex + bestPointDerivation.length - 1) % bestPointDerivation.length][1];
 		var angle = getAngle(startX, startY, targetX, targetY);
-		placeObject(centerX + bestPointDerivation[pointIndex][0], centerY + bestPointDerivation[pointIndex][1], wallStyles[style]["tower"].entity, playerId, angle - PI/2 + wallStyles[style]["tower"].angle);
+
+		var tower = getWallElement(style, "tower");
+		placeObject(centerX + bestPointDerivation[pointIndex][0], centerY + bestPointDerivation[pointIndex][1], tower.entPath, playerId, angle - PI/2 + tower.angle);
 	}
 }
Index: binaries/data/mods/public/maps/random/schwarzwald.js
===================================================================
--- binaries/data/mods/public/maps/random/schwarzwald.js
+++ binaries/data/mods/public/maps/random/schwarzwald.js
@@ -131,7 +131,7 @@ var playerAngleMaxOff = playerAngleAddAvrg/4;
 // Setup paths
 var pathSucsessRadius = baseRadius/2;
 var pathAngleOff = PI/2;
-var pathWidth = 10; // This is not really the path's thickness in tiles but the number of tiles in the clumbs of the path
+var pathWidth = 10; // This is not really the path's thickness in tiles but the number of tiles in the clumps of the path
 
 // Setup additional resources
 var resourceRadius = 2*mapRadius/3; // 3*mapRadius/8;
@@ -159,8 +159,8 @@ HeightPlacer.prototype.place = function (constraint) {
 	constraint = (constraint || new NullConstraint());
 	
     var ret = [];
-    for (var x = 0; x < g_Map.size; x++) {
-        for (var y = 0; y < g_Map.size; y++) {
+    for (var x = 0; x < g_Map.size; ++x) {
+        for (var y = 0; y < g_Map.size; ++y) {
             if (g_Map.height[x][y] >= this.lowerBound && g_Map.height[x][y] <= this.upperBound && constraint.allows(x, y)) {
                 ret.push(new PointXZ(x, y));
             }
@@ -179,7 +179,7 @@ function getOrderOfPointsForShortestClosePath(points)
 	var distances = [];
 	if (points.length <= 3)
 	{
-		for (var i = 0; i < points.length; i++)
+		for (var i = 0; i < points.length; ++i)
 			order.push(i);
 		
 		return order;
@@ -187,7 +187,7 @@ function getOrderOfPointsForShortestClosePath(points)
 	
 	// Just add the first 3 points
 	var pointsToAdd = deepcopy(points);
-	for (var i = 0; i < min(points.length, 3); i++)
+	for (var i = 0; i < min(points.length, 3); i)
 	{
 		order.push(i);
 		pointsToAdd.shift(i);
@@ -198,13 +198,13 @@ function getOrderOfPointsForShortestClosePath(points)
 	
 	// Add remaining points so the path lengthens the least
 	var numPointsToAdd = pointsToAdd.length;
-	for (var i = 0; i < numPointsToAdd; i++)
+	for (var i = 0; i < numPointsToAdd; ++i)
 	{
 		var indexToAddTo = undefined;
 		var minEnlengthen = Infinity;
 		var minDist1 = 0;
 		var minDist2 = 0;
-		for (var k = 0; k < order.length; k++)
+		for (var k = 0; k < order.length; ++k)
 		{
 			var dist1 = getDistance(pointsToAdd[0][0], pointsToAdd[0][1], points[order[k]][0], points[order[k]][1]);
 			var dist2 = getDistance(pointsToAdd[0][0], pointsToAdd[0][1], points[order[(k + 1) % order.length]][0], points[order[(k + 1) % order.length]][1]);
@@ -232,19 +232,15 @@ function getOrderOfPointsForShortestClosePath(points)
 //
 ////////////////
 
-// Some heightmap constants
-const MIN_HEIGHT = - SEA_LEVEL; // -20
-const MAX_HEIGHT = 0xFFFF/HEIGHT_UNITS_PER_METRE - SEA_LEVEL; // A bit smaller than 90
-
 // Get the diferrence between minimum and maxumum height
 function getMinAndMaxHeight(reliefmap)
 {
 	var height = {};
 	height.min = Infinity;
 	height.max = - Infinity;
-	for (var x = 0; x < reliefmap.length; x++)
+	for (var x = 0; x < reliefmap.length; ++x)
 	{
-		for (var y = 0; y < reliefmap[x].length; y++)
+		for (var y = 0; y < reliefmap[x].length; ++y)
 		{
 			if (reliefmap[x][y] < height.min)
 				height.min = reliefmap[x][y];
@@ -264,8 +260,8 @@ function rescaleHeightmap(minHeight, maxHeight, heightmap)
 	var oldHeightRange = getMinAndMaxHeight(heightmap);
 	var max_x = heightmap.length;
 	var max_y = heightmap[0].length;
-	for (var x = 0; x < max_x; x++)
-		for (var y = 0; y < max_y; y++)
+	for (var x = 0; x < max_x; ++x)
+		for (var y = 0; y < max_y; ++y)
 			heightmap[x][y] = minHeight + (heightmap[x][y] - oldHeightRange.min) / (oldHeightRange.max - oldHeightRange.min) * (maxHeight - minHeight);
 }
 
@@ -288,21 +284,21 @@ function getStartLocationsByHeightmap(hightRange, maxTries, minDistToBorder, num
 	heightmap = (heightmap || g_Map.height);
 	
 	var validStartLocTiles = [];
-	for (var x = minDistToBorder; x < heightmap.length - minDistToBorder; x++)
-		for (var y = minDistToBorder; y < heightmap[0].length - minDistToBorder; y++)
+	for (var x = minDistToBorder; x < heightmap.length - minDistToBorder; ++x)
+		for (var y = minDistToBorder; y < heightmap[0].length - minDistToBorder; ++y)
 			if (heightmap[x][y] > hightRange.min && heightmap[x][y] < hightRange.max) // Has the right hight
 				validStartLocTiles.push([x, y]);
 	
 	var maxMinDist = 0;
-	for (var tries = 0; tries < maxTries; tries++)
+	for (var tries = 0; tries < maxTries; ++tries)
 	{
 		var startLoc = [];
 		var minDist = heightmap.length;
-		for (var p = 0; p < numberOfPlayers; p++)
+		for (var p = 0; p < numberOfPlayers; ++p)
 			startLoc.push(validStartLocTiles[randInt(validStartLocTiles.length)]);
-		for (var p1 = 0; p1 < numberOfPlayers - 1; p1++)
+		for (var p1 = 0; p1 < numberOfPlayers - 1; ++p1)
 		{
-			for (var p2 = p1 + 1; p2 < numberOfPlayers; p2++)
+			for (var p2 = p1 + 1; p2 < numberOfPlayers; ++p2)
 			{
 				var dist = getDistance(startLoc[p1][0], startLoc[p1][1], startLoc[p2][0], startLoc[p2][1]);
 				if (dist < minDist)
@@ -340,19 +336,19 @@ function derivateEntitiesByHeight(hightRange, startLoc, entityList, maxTries, mi
 	
 	var placements = deepcopy(startLoc);
 	var validTiles = [];
-	for (var x = minDistance; x < heightmap.length - minDistance; x++)
-		for (var y = minDistance; y < heightmap[0].length - minDistance; y++)
+	for (var x = minDistance; x < heightmap.length - minDistance; ++x)
+		for (var y = minDistance; y < heightmap[0].length - minDistance; ++y)
 			if (heightmap[x][y] > hightRange.min && heightmap[x][y] < hightRange.max) // Has the right hight
 				validTiles.push([x, y]);
 	
 	if (!validTiles.length)
 		return;
 	
-	for (var tries = 0; tries < maxTries; tries++)
+	for (var tries = 0; tries < maxTries; ++tries)
 	{
 		var tile = validTiles[randInt(validTiles.length)];
 		var isValid = true;
-		for (var p = 0; p < placements.length; p++)
+		for (var p = 0; p < placements.length; ++p)
 		{
 			if (getDistance(placements[p][0], placements[p][1], tile[0], tile[1]) < minDistance)
 			{
@@ -395,10 +391,10 @@ function setBaseTerrainDiamondSquare(minHeight, maxHeight, smoothness, initialHe
 		var newHeightmap = [];
 		var oldWidth = initialHeightmap.length;
 		// Square
-		for (var x = 0; x < 2 * oldWidth - 1; x++)
+		for (var x = 0; x < 2 * oldWidth - 1; ++x)
 		{
 			newHeightmap.push([]);
-			for (var y = 0; y < 2 * oldWidth - 1; y++)
+			for (var y = 0; y < 2 * oldWidth - 1; ++y)
 			{
 				if (x % 2 === 0 && y % 2 === 0) // Old tile
 					newHeightmap[x].push(initialHeightmap[x/2][y/2]);
@@ -412,9 +408,9 @@ function setBaseTerrainDiamondSquare(minHeight, maxHeight, smoothness, initialHe
 			}
 		}
 		// Diamond
-		for (var x = 0; x < 2 * oldWidth - 1; x++)
+		for (var x = 0; x < 2 * oldWidth - 1; ++x)
 		{
-			for (var y = 0; y < 2 * oldWidth - 1; y++)
+			for (var y = 0; y < 2 * oldWidth - 1; ++y)
 			{
 				if (newHeightmap[x][y] === undefined)
 				{
@@ -452,8 +448,8 @@ function setBaseTerrainDiamondSquare(minHeight, maxHeight, smoothness, initialHe
 	
 	// Cut initialHeightmap to fit target width
 	var shift = [floor((newHeightmap.length - heightmap.length) / 2), floor((newHeightmap[0].length - heightmap[0].length) / 2)];
-	for (var x = 0; x < heightmap.length; x++)
-		for (var y = 0; y < heightmap[0].length; y++)
+	for (var x = 0; x < heightmap.length; ++x)
+		for (var y = 0; y < heightmap[0].length; ++y)
 			heightmap[x][y] = newHeightmap[x][y];
 }
 
@@ -474,9 +470,9 @@ function decayErrodeHeightmap(strength, heightmap)
 	var map = [[1, 0], [1, 1], [0, 1], [-1, 1], [-1, 0], [-1, -1], [0, -1], [1, -1]]; // smoother
 	var max_x = heightmap.length;
 	var max_y = heightmap[0].length;
-	for (var x = 0; x < max_x; x++)
-		for (var y = 0; y < max_y; y++)
-			for (var i = 0; i < map.length; i++)
+	for (var x = 0; x < max_x; ++x)
+		for (var y = 0; y < max_y; ++y)
+			for (var i = 0; i < map.length; ++i)
 				heightmap[x][y] += strength / map.length * (referenceHeightmap[(x + map[i][0] + max_x) % max_x][(y + map[i][1] + max_y) % max_y] - referenceHeightmap[x][y]); // Not entirely sure if scaling with map.length is perfect but tested values seam to indicate it is
 }
 
@@ -490,10 +486,10 @@ function rectangularSmoothToHeight(center, dx, dy, targetHeight, strength, heigh
 	heightmap = (heightmap || g_Map.height);
 	
 	var heightmapWin = [];
-	for (var wx = 0; wx < 2 * dx + 1; wx++)
+	for (var wx = 0; wx < 2 * dx + 1; ++wx)
 	{
 		heightmapWin.push([]);
-		for (var wy = 0; wy < 2 * dy + 1; wy++)
+		for (var wy = 0; wy < 2 * dy + 1; ++wy)
 		{
 			var actualX = x - dx + wx;
 			var actualY = y - dy + wy;
@@ -503,9 +499,9 @@ function rectangularSmoothToHeight(center, dx, dy, targetHeight, strength, heigh
 				heightmapWin[wx].push(targetHeight);
 		}
 	}
-	for (var wx = 0; wx < 2 * dx + 1; wx++)
+	for (var wx = 0; wx < 2 * dx + 1; ++wx)
 	{
-		for (var wy = 0; wy < 2 * dy + 1; wy++)
+		for (var wy = 0; wy < 2 * dy + 1; ++wy)
 		{
 			var actualX = x - dx + wx;
 			var actualY = y - dy + wy;
@@ -550,7 +546,7 @@ var initialReliefmap = [[heightRange.max, heightRange.max, heightRange.max], [he
 
 setBaseTerrainDiamondSquare(heightRange.min, heightRange.max, 0.5, initialReliefmap, g_Map.height);
 // Apply simple erosion
-for (var i = 0; i < 5; i++)
+for (var i = 0; i < 5; ++i)
 	decayErrodeHeightmap(0.5);
 rescaleHeightmap(heightRange.min, heightRange.max);
 
@@ -582,7 +578,7 @@ var heighLimits = [
 var startLocations = getStartLocationsByHeightmap({'min': heighLimits[4], 'max': heighLimits[5]});
 var playerHeight = (heighLimits[4] + heighLimits[5]) / 2;
 
-for (var i=0; i < numPlayers; i++)
+for (var i=0; i < numPlayers; ++i)
 {
 	playerAngle[i] = (playerAngleStart + i*playerAngleAddAvrg + randFloat(0, playerAngleMaxOff))%(2*PI);
 	var x = round(mapCenterX + randFloat(minPlayerRadius, maxPlayerRadius)*cos(playerAngle[i]));
@@ -604,7 +600,7 @@ for (var i=0; i < numPlayers; i++)
 	var distToSL = 15;
 	var resStartAngle = playerAngle[i] + PI;
 	var resAddAngle = 2*PI / startingResources.length;
-	for (var rIndex = 0; rIndex < startingResources.length; rIndex++)
+	for (var rIndex = 0; rIndex < startingResources.length; ++rIndex)
 	{
 		var angleOff = randFloat(-resAddAngle/2, resAddAngle/2);
 		var placeX = x + distToSL*cos(resStartAngle + rIndex*resAddAngle + angleOff);
@@ -644,13 +640,13 @@ if (doublePaths === true)
 	var maxI = numPlayers+1;
 else
 	var maxI = numPlayers;
-for (var i = 0; i < maxI; i++)
+for (var i = 0; i < maxI; ++i)
 {
 	if (doublePaths === true)
 		var minJ = 0;
 	else
 		var minJ = i+1;
-	for (var j = minJ; j < numPlayers+1; j++)
+	for (var j = minJ; j < numPlayers+1; ++j)
 	{
 		// Setup start and target coordinates
 		if (i < numPlayers)
@@ -700,7 +696,7 @@ for (var i = 0; i < maxI; i++)
 			}
 			if (getDistance(x, z, targetX, targetZ) < pathSucsessRadius)
 				targetReached = true;
-			tries++;
+			++tries;
 
 		}
 	}
@@ -761,14 +757,14 @@ RMS.SetProgress(90);
 
 // place trees
 log("Planting trees...");
-for (var x = 0; x < mapSize; x++)
+for (var x = 0; x < mapSize; ++x)
 {
-	for (var z = 0;z < mapSize;z++)
+	for (var z = 0; z < mapSize; ++z)
 	{
 		// Some variables
 		var radius = Math.pow(Math.pow(mapCenterX - x - 0.5, 2) + Math.pow(mapCenterZ - z - 0.5, 2), 1/2); // The 0.5 is a correction for the entities placed on the center of tiles
 		var minDistToSL = mapSize;
-		for (var i=0; i < numPlayers; i++)
+		for (var i=0; i < numPlayers; ++i)
 			minDistToSL = min(minDistToSL, getDistance(playerStartLocX[i], playerStartLocZ[i], x, z));
 		// Woods tile based
 		var tDensFactSL = max(min((minDistToSL - baseRadius) / baseRadius, 1), 0);
Index: binaries/data/mods/public/maps/random/wall_demo.js
===================================================================
--- binaries/data/mods/public/maps/random/wall_demo.js
+++ binaries/data/mods/public/maps/random/wall_demo.js
@@ -61,33 +61,31 @@ const distToOtherWalls = 10;
 var buildableMapSize = mapSize - 2 * distToMapBorder;
 var actualX = distToMapBorder;
 var actualY = distToMapBorder;
-// Wall styles are chosen by strings so the civ strings got by getCivCode() can be used
-// Other styles may be present as well but besides the civ styles only 'palisades' includes all wall element types (yet)
-const wallStyleList = ["athen", "brit", "cart", "gaul", "iber", "mace", "maur", "pers", "ptol", "rome", "sele", "spart", "rome_siege", "palisades"];
-
+var wallStyleList = g_WallStyleList;
 
 ////////////////////////////////////////
 // Custom wall placement (element based)
 ////////////////////////////////////////
-var wall = ['endLeft', 'wallLong', 'tower', 'wall', 'outpost', 'wall', 'cornerOut', 'wall', 'cornerIn', 'wall', 'house', 'endRight', 'entryTower', 'endLeft', 'wallShort', 'barracks', 'gate', 'tower', 'wall', 'wallFort', 'wall', 'endRight'];
-for (var styleIndex = 0; styleIndex < wallStyleList.length; styleIndex++)
+var wall = ['start', 'long', 'tower', 'tower', 'tower', 'medium', 'outpost', 'medium', 'cornerOut', 'medium', 'cornerIn', 'medium', 'house', 'end', 'entryTower', 'start', 'short', 'barracks', 'gate', 'tower', 'medium', 'fort', 'medium', 'end'];
+for (var styleIndex = 0; styleIndex < wallStyleList.length; ++styleIndex)
 {
 	var startX = actualX + styleIndex * buildableMapSize/wallStyleList.length; // X coordinate of the first wall element
 	var startY = actualY; // Y coordinate of the first wall element
-	var style = wallStyleList[styleIndex]; // // The wall's style like 'cart', 'iber', 'pers', 'rome', 'romeSiege' or 'palisades'
-	var orientation = styleIndex * PI/64; // Orientation of the first wall element. 0 means 'outside' or 'front' is right (positive X, like object placement)
+	var style = wallStyleList[styleIndex]; // The wall's style like 'cart', 'iber', 'pers', 'rome', 'romeSiege' or 'palisades'
+	var orientation = PI/16 * sin(styleIndex * PI/4); // Orientation of the first wall element. 0 means 'outside' or 'front' is right (positive X, like object placement in Atlas)
 	// That means the wall will be build towards top (positive Y) if no corners are used
 	var playerId = 0; // Owner of the wall (like in placeObject). 0 is Gaia, 1 is Player 1 (default color blue), ...
-	placeWall(startX, startY, wall, style, playerId, orientation); // Actually placing the wall
+	placeWall(startX, startY, wall, style, playerId, orientation); // Actually place the wall
 }
 actualX = distToMapBorder; // Reset actualX
 actualY += 80 + distToOtherWalls; // Increase actualY for next wall placement method
 
+
 //////////////////////////////////////////////////////////////
 // Default fortress placement (chosen by fortress type string)
 //////////////////////////////////////////////////////////////
 var fortressRadius = 15; // The space the fortresses take in average. Just for design of this map
-for (var styleIndex = 0; styleIndex < wallStyleList.length; styleIndex++)
+for (var styleIndex = 0; styleIndex < wallStyleList.length; ++styleIndex)
 {
 	var centerX = actualX + fortressRadius + styleIndex * buildableMapSize/wallStyleList.length; // X coordinate of the center of the fortress
 	var centerY = actualY + fortressRadius; // Y coordinate of the center of the fortress
@@ -99,7 +97,23 @@ for (var styleIndex = 0; styleIndex < wallStyleList.length; styleIndex++)
 	placeObject(centerX, centerY, 'other/obelisk', 0, 0*PI); // Place visual marker to see the center of the fortress
 }
 actualX = distToMapBorder; // Reset actualX
-actualY += 2 * fortressRadius + 2 * distToOtherWalls; // Increase actualY for next wall placement method
+actualY += 2 * fortressRadius + distToOtherWalls; // Increase actualY for next wall placement method
+
+//////////////////////////////////////////////////////////////
+// 'generic' fortress placement (iberian wall circuit code)
+//////////////////////////////////////////////////////////////
+var radius = min((mapSize - actualY - distToOtherWalls) / 3, (buildableMapSize / wallStyleList.length - distToOtherWalls) / 2); // The radius of wall circle
+for (var styleIndex = 0; styleIndex < wallStyleList.length; ++styleIndex)
+{
+	var centerX = actualX + radius + styleIndex * buildableMapSize/wallStyleList.length; // X coordinate of the center of the fortress
+	var centerY = actualY + radius; // Y coordinate of the center of the fortress
+	var style = wallStyleList[styleIndex]; // The wall's style like 'cart', 'iber', 'pers', 'rome', 'romeSiege' or 'palisades'
+	var playerId = 0; // Owner of the wall. 0 is Gaia, 1 is Player 1 (default color blue), ...
+	placeGenericFortress(centerX, centerY, radius, playerId, style); // Actually place the fortress
+	placeObject(centerX, centerY, 'other/obelisk', 0, 0*PI); // Place visual marker to see the center of the fortress
+}
+actualX = distToMapBorder; // Reset actualX
+actualY += 2 * radius + distToOtherWalls; // Increase actualY for next wall placement method
 
 //////////////////////////
 // Circular wall placement
@@ -108,11 +122,11 @@ actualY += 2 * fortressRadius + 2 * distToOtherWalls; // Increase actualY for ne
 var radius = min((mapSize - actualY - distToOtherWalls) / 3, (buildableMapSize / wallStyleList.length - distToOtherWalls) / 2); // The radius of wall circle
 var centerY = actualY + radius; // Y coordinate of the center of the wall circle
 var orientation = 0; // Where the wall circle will be open if maxAngle < 2*PI, see below. Otherwise where the first wall element will be placed
-for (var styleIndex = 0; styleIndex < wallStyleList.length; styleIndex++)
+for (var styleIndex = 0; styleIndex < wallStyleList.length; ++styleIndex)
 {
 	var centerX = actualX + radius + styleIndex * buildableMapSize/wallStyleList.length; // X coordinate of the center of the wall circle
 	var playerId = 0; // Player ID of the player owning the wall, 0 is Gaia, 1 is the first player (default blue), ...
-	var wallPart = ['tower', 'wall', 'house']; // List of wall elements the wall will be build of. Optional, default id ['wall']
+	var wallPart = ['tower', 'medium', 'house']; // List of wall elements the wall will be build of. Optional, default id ['wall']
 	var style = wallStyleList[styleIndex]; // The wall's style like 'cart', 'iber', 'pers', 'rome', 'romeSiege' or 'palisades'
 	var maxAngle = PI/2 * (styleIndex%3 + 2); // How far the wall should circumvent the center
 	placeCircularWall(centerX, centerY, radius, wallPart, style, playerId, orientation, maxAngle); // Actually placing the wall
@@ -122,19 +136,19 @@ for (var styleIndex = 0; styleIndex < wallStyleList.length; styleIndex++)
 actualX = distToMapBorder; // Reset actualX
 actualY += 2 * radius + distToOtherWalls; // Increase actualY for next wall placement method
 
-///////////////////////////
-// Polygonal wall placement
-///////////////////////////
+///////////////////////////////////
+// Regular Polygonal wall placement
+///////////////////////////////////
 // NOTE: Don't use bending wall elements like corners here!
 var radius = min((mapSize - actualY - distToOtherWalls) / 2, (buildableMapSize / wallStyleList.length - distToOtherWalls) / 2); // The radius of wall polygons
 var centerY = actualY + radius; // Y coordinate of the center of the wall polygon
 var orientation = 0; // Where the wall circle will be open if ???, see below. Otherwise where the first wall will be placed
-for (var styleIndex = 0; styleIndex < wallStyleList.length; styleIndex++)
+for (var styleIndex = 0; styleIndex < wallStyleList.length; ++styleIndex)
 {
 	var centerX = actualX + radius + styleIndex * buildableMapSize/wallStyleList.length; // X coordinate of the center of the wall circle
 	var playerId = 0; // Player ID of the player owning the wall, 0 is Gaia, 1 is the first player (default blue), ...
 	var cornerWallElement = 'tower'; // With wall element type will be uset for the corners of the polygon
-	var wallPart = ['wall', 'tower']; // List of wall elements the wall will be build of. Optional, default id ['wall']
+	var wallPart = ['medium', 'tower']; // List of wall elements the wall will be build of. Optional, default id ['wall']
 	var style = wallStyleList[styleIndex]; // The wall's style like 'cart', 'iber', 'pers', 'rome', 'romeSiege' or 'palisades'
 	var numCorners = (styleIndex)%6 + 3; // How many corners the plogon will have
 	var skipFirstWall = true; // If the wall should be open towards orientation
@@ -145,30 +159,51 @@ for (var styleIndex = 0; styleIndex < wallStyleList.length; styleIndex++)
 actualX = distToMapBorder; // Reset actualX
 actualY += 2 * radius + distToOtherWalls; // Increase actualY for next wall placement method
 
+/////////////////////////////////////
+// Irregular Polygonal wall placement
+/////////////////////////////////////
+// NOTE: Don't use bending wall elements like corners here!
+var radius = min((mapSize - actualY - distToOtherWalls) / 2, (buildableMapSize / wallStyleList.length - distToOtherWalls) / 2); // The radius of wall polygons
+var centerY = actualY + radius; // Y coordinate of the center of the wall polygon
+var orientation = 0; // Where the wall circle will be open if ???, see below. Otherwise where the first wall will be placed
+for (var styleIndex = 0; styleIndex < wallStyleList.length; ++styleIndex)
+{
+	var centerX = actualX + radius + styleIndex * buildableMapSize/wallStyleList.length; // X coordinate of the center of the wall circle
+	var playerId = 0; // Player ID of the player owning the wall, 0 is Gaia, 1 is the first player (default blue), ...
+	var cornerWallElement = 'tower'; // With wall element type will be uset for the corners of the polygon
+	var style = wallStyleList[styleIndex]; // The wall's style like 'cart', 'iber', 'pers', 'rome', 'romeSiege' or 'palisades'
+	var numCorners = (styleIndex)%6 + 3; // How many corners the plogon will have
+	var skipFirstWall = true; // If the wall should be open towards orientation
+	placeIrregularPolygonalWall(centerX, centerY, radius, cornerWallElement, style, playerId, orientation, numCorners, undefined, skipFirstWall);
+	placeObject(centerX, centerY, 'other/obelisk', 0, 0*PI); // Place visual marker to see the center of the wall circle
+	orientation += PI/16; // Increasing orientation to see how rotation works (like for object placement)
+}
+actualX = distToMapBorder; // Reset actualX
+actualY += 2 * radius + distToOtherWalls; // Increase actualY for next wall placement method
+
+
 ////////////////////////
 // Linear wall placement
 ////////////////////////
 // NOTE: Don't use bending wall elements like corners here!
 var maxWallLength = (mapSize - actualY - distToMapBorder - distToOtherWalls); // Just for this maps design. How long the longest wall will be
 var numWallsPerStyle = floor(buildableMapSize / distToOtherWalls / wallStyleList.length); // Just for this maps design. How many walls of the same style will be placed
-for (var styleIndex = 0; styleIndex < wallStyleList.length; styleIndex++)
+for (var styleIndex = 0; styleIndex < wallStyleList.length; ++styleIndex)
 {
-	for (var wallIndex = 0; wallIndex < numWallsPerStyle; wallIndex++)
+	for (var wallIndex = 0; wallIndex < numWallsPerStyle; ++wallIndex)
 	{
-		var startX = actualX + (styleIndex * numWallsPerStyle + wallIndex) * distToOtherWalls; // X coordinate the wall will start from
+		var startX = actualX + (styleIndex * numWallsPerStyle + wallIndex) * buildableMapSize/wallStyleList.length/numWallsPerStyle; // X coordinate the wall will start from
 		var startY = actualY; // Y coordinate the wall will start from
 		var endX = startX; // X coordinate the wall will end
 		var endY = actualY + (wallIndex + 1) * maxWallLength/numWallsPerStyle; // Y coordinate the wall will end
 		var playerId = 0; // Player ID of the player owning the wall, 0 is Gaia, 1 is the first player (default blue), ...
-		var wallPart = ['tower', 'wall']; // List of wall elements the wall will be build of
+		var wallPart = ['tower', 'medium']; // List of wall elements the wall will be build of
 		var style = wallStyleList[styleIndex]; // The wall's style like 'cart', 'iber', 'pers', 'rome', 'romeSiege' or 'palisades'
 		placeLinearWall(startX, startY, endX, endY, wallPart, style, playerId); // Actually placing the wall
 		// placeObject(startX, startY, 'other/obelisk', 0, 0*PI); // Place visual marker to see where exsactly the wall begins
 		// placeObject(endX, endY, 'other/obelisk', 0, 0*PI); // Place visual marker to see where exsactly the wall ends
 	}
 }
-actualX = distToMapBorder; // Reset actualX
-actualY += maxWallLength + distToOtherWalls; // Increase actualY for next wall placement method
 
 
 // Export map data
Index: binaries/data/mods/public/simulation/components/WallPiece.js
===================================================================
--- binaries/data/mods/public/simulation/components/WallPiece.js
+++ binaries/data/mods/public/simulation/components/WallPiece.js
@@ -6,7 +6,22 @@ WallPiece.prototype.Schema =
 	"</a:example>" +
 	"<element name='Length'>" +
 		"<ref name='nonNegativeDecimal'/>" +
-    "</element>";
+    "</element>" +
+    "<optional>" +
+		"<element name='Orientation'>" +
+			"<ref name='nonNegativeDecimal'/>" +
+		"</element>" +
+	"</optional>" +
+	"<optional>" +
+		"<element name='Indent'>" +
+			"<data type='decimal'/>" +
+		"</element>" +
+	"</optional>" +
+	"<optional>" +
+		"<element name='Bend'>" +
+			"<data type='decimal'/>" +
+		"</element>" +
+	"</optional>";
 
 
 WallPiece.prototype.Init = function()
